
/*
Christof Ermer  Regensburg
02.08.2018
Fermikurve.c
*/

#define PROG_NAME  "FunktionX"

#pragma comment(lib,"libgdi32.a")   // einbinden von lib

#include <windows.h>
#include <iostream>
#include <limits>
#include <stdexcept>

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <stdint.h>
#include <time.h>
#include <math.h>
#include "main.h"
#include "MyCodeTools.h"

using namespace std;
//GLOBAL
HWND hWnd;
HDC hDC;
//HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
//CONSOLE_SCREEN_BUFFER_INFO sConScreenInf;

// ******************************
void KreuzZeichnen(void)
// ******************************
{
uint16_t i16NN;
//KREUZ
for( i16NN = 0 ; i16NN < WIN_X_WIDTH ; i16NN++)
	{
	SetPixel(hDC, i16NN, WIN_Y_MITTE, RGB(255, 255, 0));				
	};
for( i16NN = 0 ; i16NN < WIN_Y_WIDTH ; i16NN++)
	{
	SetPixel(hDC, WIN_X_MITTE, i16NN, RGB(255, 0, 255));				
	};
};

// ******************************
void PLotX_ToY( double dXX, double  dYY)  //Normiert auf 0
// ******************************
{
uint16_t u16WIN_X = round( dXX ) + WIN_X_MITTE;
uint16_t u16WIN_Y = (round( dYY ) * -1.0) + WIN_Y_MITTE;

if( (u16WIN_X < WIN_X_WIDTH) && (u16WIN_Y < WIN_Y_WIDTH) )
	{
	SetPixel(hDC, u16WIN_X, u16WIN_Y , RGB(255, 255, 255));				
	}
};

// ****************************************************************
void FunktionSinus( void )
// ****************************************************************
{
int16_t i16XPos;
for(i16XPos = 0; i16XPos < X_RESOLUTON; i16XPos++)	 //0..1024
	{
	SetPixel(hDC, i16XPos, WIN_Y_MITTE + (WIN_Y_MITTE-1) * sin(2*M_PI* i16XPos/(float)X_RESOLUTON), RGB(255, 255, 255));	
	};
};

// ****************************************************************
void FunktionX( float fX_LowestValue, float fX_HighestValue, float fY_Expected_MIN_Value, float fY_Expected_MAX_Value)
// ****************************************************************
{
int16_t i16XPos;
int16_t i16YPos;
float f16XX;	//realer X
float f16YY;	//realer y
float fY_Plotval;

//LEGE RECHNBEREICH FEST
#define CHARMAX_X	128
#define CHARMAX_Y	80
//-512..+512
for(i16XPos = 0; i16XPos < X_RESOLUTON; i16XPos++)	 //0..1024
	{
	//generiere passenden X Normiert auf Plotscala 
	f16XX = fX_LowestValue + (((fX_HighestValue - fX_LowestValue )/(float)X_RESOLUTON) * i16XPos);
	//Funktion
	// F(x) = 2X^2+5
	f16YY = 1 / ( 1+ exp( -1*(f16XX) ) );

	//Normiere auf PLOTscala
	fY_Plotval = f16YY * ((float)Y_RESOLUTON)/(fY_Expected_MAX_Value - fY_Expected_MIN_Value);
	PLotX_ToY( i16XPos-WIN_X_MITTE , fY_Plotval ); 
	//PLotX_ToY( i16XPos-WIN_X_MITTE , i16XPos-WIN_X_MITTE ); 
	gotoxy(1,0);
	PrintSpaces(30);
	gotoxy(1,0);
	printf("\r\nu16XPos=%d=X:%f    ply%f=Y:%f   ",i16XPos-WIN_X_MITTE,f16XX, (round( fY_Plotval ) * -1.0) + WIN_Y_MITTE, f16YY );
 	//Sleep(100);
	};
//AchseBeschriften(fX_LowestValue, fX_HighestValue, fY_Expected_MAX_Value, fY_Expected_MIN_Value);
KreuzZeichnen();
};

// ******************************
int main(void)
// ******************************
{

//https://docs.microsoft.com/en-us/windows/console/creation-of-a-console
//https://docs.microsoft.com/en-us/windows/console/getconsolewindow

   //HWND hWnd = FindWindow(NULL, "Grafik in Dos");
    //alternative zu FindWindow 
//SMALL_RECT windowSize = {0, 0, WIN_X_WIDTH, WIN_Y_WIDTH};
//hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
hWnd = GetConsoleWindow();
if( hWnd != NULL )
	{
	hDC = GetDC(hWnd); 
	SetConsoleTitle( PROG_NAME );  
	//MoveWindow(hWnd,100,100,windowWidth,windowHeight,FALSE);
	MoveWindow(hWnd ,100,10 ,WIN_X_WIDTH+ADDITIONAL_X, WIN_Y_WIDTH+ADDITIONAL_Y, TRUE); //TRUE	
	//SetWindowPos( gHwnd, 0, 50, 50, 0, 0, SWP_NOSIZE | SWP_NOZORDER );

/*
	if(!SetConsoleWindowInfo(hConsole, TRUE, &windowSize))
		{
			cout << "SetConsoleWindowInfo failed with error " << GetLastError() << endl;
			return -1;
		}
*/
	}
else
	{
	return -1;
}	;
/*
//GetCursorposition
//console con( 80, 200 );
//SetConsoleWindowInfo
SetConsoleScreenBufferSize
*/	
	system("cls"); 
	gotoxy(0,0);
	KreuzZeichnen();        
	FunktionX(-5,5,-1.2,1.2);
	printf("\n\rSinus soll nur den Wertebereich zeigen"); // beep
	FunktionSinus();
	//CheckPrint();
 	//gotoxy(0,4);
	//printf("\n\r\r%f", AhochX(2,16) );
	ReleaseDC(hWnd, hDC);
    DeleteDC(hDC);
    //std::cin.get();
printf("\n\r\a"); // beep
    system("pause");   
	return 0;        
};/* run this program using the console pauser or add your own getch, system("pause") or input loop */

